-- Sonic the Hedgehog 4 by Sonic Team and Dimps
-- S4esque by RubyTheMii

-- Sonic's physics are based on Sonic 4: Episode I. Episode II physics for Tails are planned to be added in a future update.
-- Metal Sonic may also be included, but don't hold your breath.
sfxinfo[freeslot("sfx_collok")].caption = "Locking onto something"

-- Simple function for checking if you're on the ground.
rawset(_G, "IsGrounded", function(mo)
	return (P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR)
end)

addHook("PlayerSpawn", function(player)
	player.lockonsound = false; player.s4_hasbubbled = false; player.s4_thokvuln = false; player.s4_nuhuh = false; player.s4_springing = false; player.s4_hominghit = false
end)

addHook("PlayerThink", function(player)
	player.lockonsound = $ or false; player.s4_hasbubbled = $ or false
	player.s4_thokvuln = $ or false; player.s4_nuhuh = $ or false; player.s4_springing = $ or false; player.s4_hominghit = $ or false
	if player.mo and player.mo.skin == "sonic" then
		if not (player.mo.target and player.mo.target.valid) then
			player.charflags = $ & ~SF_MULTIABILITY
		end
		if IsGrounded(player.mo) then
			player.accelstart = skins[player.mo.skin].accelstart*1; player.acceleration = skins[player.mo.skin].acceleration*1; player.s4_thokvuln = false
		end
		-- Have Sonic... not air walk? ...and get out of his roll state when flying off ledges
		if not IsGrounded(player.mo) and player.pflags & PF_SHIELDABILITY == 0 and player.pflags & PF_JUMPED == 0 and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or player.powers[pw_carry]) then
			if not (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GASP) then
				player.mo.state = S_PLAY_SPRING
			end
			if player.pflags & PF_SPINNING then
				player.pflags = $ & ~PF_SPINNING
			end
			player.pflags = $1|PF_JUMPED
		end
		-- Determines when you should become vulnerable after thokking.
		if player.pflags & PF_THOKKED then player.pflags = $ & ~PF_STARTJUMP
			if player.s4_thokvuln == false and player.mo.state != S_PLAY_ROLL then player.mo.state = S_PLAY_ROLL end
			if player.homing == 0 and player.s4_thokvuln == false and player.s4_nuhuh == false and (leveltime % TICRATE/3 == 0) and player.mo.state == S_PLAY_ROLL then player.mo.state = S_PLAY_SPRING; player.s4_thokvuln = true; end
		end
		-- Special case stuff
		if player.s4_springing == true then
			player.accelstart = skins[player.mo.skin].accelstart*2; player.acceleration = skins[player.mo.skin].acceleration*3/2
			if (leveltime % TICRATE/4 > 0) then
				player.powers[pw_nocontrol] = 1<<16; player.pflags = $1|PF_STASIS
			else
				player.s4_springing = false
			end
		end
		if player.s4_hominghit == true then
			if player.mo.state != S_PLAY_SPRING or player.mo.state != S_PLAY_FALL then
				player.mo.state = S_PLAY_SPRING
			end
		    if (leveltime % TICRATE*3/4 > 0) then
				P_SpawnThokMobj(player)
			end
			P_InstaThrust(player.mo, player.mo.angle, -20*FRACUNIT); player.powers[pw_nocontrol] = 1<<16; player.pflags = $1|PF_FULLSTASIS
			if (leveltime % TICRATE*3/4 == 0) or IsGrounded(player.mo) then
				player.s4_hominghit = false; player.pflags = $ & ~PF_THOKKED
			end
		end
		/* if player.s4_hasbubbled == true then
			if player.mo.state == S_PLAY_GASP and player.mo.tics == 1 then
				player.mo.state = S_PLAY_ROLL; player.mo.frame = E & ~FF_ANIMATE
			end
			if (leveltime % TICRATE*(7/8) > 0) then
				P_InstaThrust(player.mo, player.mo.angle, 0); P_SetObjectMomZ(player.mo, 0, false); player.powers[pw_underwater] = underwatertics
			else
				if not IsGrounded(player.mo) and (player.mo.state == S_PLAY_ROLL and player.mo.frame == E) then
					player.mo.state = S_PLAY_FALL
				elseif IsGrounded(player.mo) then
					player.mo.state = S_PLAY_STND
				end
				player.s4_hasbubbled = false
			end
		end */
		-- Thok stuff
		if player.homing > 0 and player.s4_springing == false then
			if player.actionspd != 100*FRACUNIT then
				player.actionspd = 100*FRACUNIT
			end
		elseif player.homing == 0 or player.s4_springing == true then
			if FixedHypot(player.rmomx, player.rmomy) <= player.normalspeed/2 then
				if (player.powers[pw_super] or player.powers[pw_sneakers]) then
					if player.actionspd != 40*FRACUNIT then
						player.actionspd = 40*FRACUNIT
					end
				else
					if player.actionspd != 24*FRACUNIT then
						player.actionspd = 24*FRACUNIT
					end
				end
			else
				if (player.powers[pw_super] or player.powers[pw_sneakers] or FixedHypot(player.rmomx, player.rmomy) >= player.normalspeed*3/2) then
					if player.actionspd != 80*FRACUNIT then
						player.actionspd = 80*FRACUNIT
					end
				else
					if player.actionspd != 55*FRACUNIT then
						player.actionspd = 55*FRACUNIT
					end
				end
			end
		end
		-- Play the Colors lock-on sound!
		if player.pflags & PF_JUMPED and not player.homing then
			local lockon = P_LookForEnemies(player, true, true)
			if lockon and lockon.valid and lockon.type != MT_BUMPER and player.lockonsound == false and R_PointToDist2(player.mo.x, player.mo.y, lockon.x, lockon.y) <= RING_DIST*3/4 then
				player.charability = CA_HOMINGTHOK; S_StartSound(player.mo, sfx_collok, player); player.lockonsound = true
			elseif not (lockon and lockon.valid) or R_PointToDist2(player.mo.x, player.mo.y, lockon.x, lockon.y) > RING_DIST*3/4 or IsGrounded(player.mo) then
				player.charability = CA_THOK; player.lockonsound = false -- Prepare to play it again for another target.
			end
		end
		-- Slow down while not holding movement keys
		local FU = FRACUNIT
		if P_IsObjectOnGround(player.mo) then FU = FRACUNIT; else FU = 7*FRACUNIT end
		if player.playerstate == PST_LIVE and player.cmomx == 0 and player.cmomy == 0 and not (player.mo.state == S_PLAY_PAIN or player.powers[pw_nocontrol] or player.powers[pw_carry] or player.s4_springing or player.s4_hominghit) then
			if FixedHypot(player.rmomx, player.rmomy) != 0 and not (player.cmd.forwardmove or player.cmd.sidemove) and player.pflags & PF_THOKKED == 0 then
				if FixedHypot(player.rmomx, player.rmomy) >= FU then
					P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), FixedHypot(player.rmomx, player.rmomy)-FU)
				elseif FixedHypot(player.rmomx, player.rmomy) <= -FU then
					P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy)+ANGLE_180, FixedHypot(player.rmomx, player.rmomx)+FU)
				else
					P_InstaThrust(player.mo, player.mo.angle, 0)
				end
			end
		end
	end
end)

addHook("MobjCollide", function(mo, bj)
	if not (mo and mo.valid and bj and bj.valid and bj.player and bj.skin == "sonic" and bj.z < mo.z+mo.height and mo.z < bj.z+bj.height) then return nil end
	if mo.flags & MF_SPRING then
		if mo.info.damage == 0 and mo.type != MT_BUMPER then
			P_InstaThrust(bj, bj.angle, 0)
		end
		-- Allow thokking after bouncing off springs
		if mo.info.mass > 0 and mo.type != MT_BUMPER then
			bj.player.pflags = $1|PF_JUMPED; bj.player.s4_springing = true
		end
		if mo.type == MT_BUMPER then bj.player.s4_nuhuh = true; bj.player.pflags = $ & ~PF_THOKKED end
	end
end)

-- Damage and death hooks, player movement related
addHook("MobjDamage", function(mo, bj)
	if mo and mo.valid and bj and bj.valid and bj.player and bj.skin == "sonic" and bj.player.pflags & PF_THOKKED then
		if (mo.flags & MF_ENEMY|MF_MONITOR and mo.health > 1) or mo.flags & MF_BOSS then
			P_SetObjectMomZ(bj, 4*FRACUNIT, false); bj.player.s4_hominghit = true
		end
		if bj.player.homing == 0 and bj.state == S_PLAY_ROLL and bj.player.s4_thokvuln == false then bj.player.s4_nuhuh = true end
	end
end)
addHook("MobjDeath", function(mo, bj)
	if mo and mo.valid and bj and bj.valid and bj.player and bj.skin == "sonic" and bj.player.pflags & PF_THOKKED then
	    if mo.flags & MF_ENEMY|MF_MONITOR then
			bj.player.pflags = $1|PF_JUMPED; bj.player.s4_springing = true; bj.player.lockonsound = false
		elseif mo.flags & MF_BOSS then
			P_SetObjectMomZ(bj, 4*FRACUNIT, false); bj.player.s4_hominghit = true; bj.player.lockonsound = false
		end
	end
end)

-- Halt your vertical momentum for about a second after grabbing a bubble (unused code)
/* addHook("TouchSpecial", function(mo, bj)
	if mo and bj and mo.valid and bj.valid and bj.skin == "sonic" and bj.player and bj.player.s4_hasbubbled == false then
	   bj.player.s4_hasbubbled = true
	end
end, MT_EXTRALARGEBUBBLE) */

-- Remove upward momentum and curl up player after thok
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.skin == "sonic" then
		if player.pflags & PF_THOKKED == 0 and player.homing == 0 and player.mo.momz >= 0 then player.mo.state = S_PLAY_ROLL; P_SetObjectMomZ(player.mo, 0, false) end
	end
end)

-- Additive blending for Thok trail
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.target and mo.target.player and mo.target.valid then
		if mo.target.skin == "sonic" then mo.blendmode = AST_ADD end
	end
end, MT_THOK)

-- Remove Super Sonic float
addHook("JumpSpinSpecial", function(player)
	if player.mo and player.mo.skin == "sonic" and player.powers[pw_super] then return true end
end)

-- No damage? <:(
addHook("PlayerCanDamage", function(player)
	if player.mo and player.mo.skin == "sonic" then
		if (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL) and player.pflags & PF_THOKKED == 0 then return false end
		if player.s4_thokvuln == true and not player.powers[pw_super] then return false end
	end
end)